import { Registry } from "prom-client";
import { IAutometricCallOptions, IAutometricCreateOptions } from "./common";
export interface ICreateAutometricPromiseOptions extends IAutometricCreateOptions {
    labels?: {
        [name: string]: string;
    };
    promise?: PromiseConstructorLike;
}
export interface IAutometricPromiseOptions extends IAutometricCallOptions {
    /**
     * A callback function to convert the labels after getting the result
     *
     * *Note: The result is the value from a resolved promise and also the error of a rejected!*
     */
    rewriteLabels?: (currentLabels: {
        [name: string]: string;
    }, result: any, createOptions: ICreateAutometricPromiseOptions, callOptions: IAutometricPromiseOptions) => {
        [name: string]: string;
    };
}
export interface IAutometricPromiseLike<T> extends PromiseLike<T> {
}
export interface IAutometricPromiseLikeConstructor extends PromiseConstructor {
    readonly register: Registry;
    readonly prefix: string;
    readonly labels: {
        [name: string]: string;
    };
    new <T>(): IAutometricPromiseLike<T>;
}
export declare function createAutometricPromise(name: string, baseOptions?: ICreateAutometricPromiseOptions): IAutometricPromiseLikeConstructor;
