/// <reference types="node" />
import { Registry } from "prom-client";
import { PassThrough } from "stream";
import { IAutometricCallOptions, IAutometricCreateOptions } from "./common";
export interface IAutometricStreamOptions extends IAutometricCallOptions {
    /**
     * A callback function to convert the labels after getting the result
     *
     * *Note: The result is the value from a resolved promise and also the error of a rejected!*
     */
    rewriteLabels?: (currentLabels: {
        [name: string]: string;
    }, chunk: any, encoding: any, createOptions: IAutometricCreateOptions, callOptions: IAutometricStreamOptions) => {
        [name: string]: string;
    };
}
export interface IAutometricStreamPipeConstructor {
    readonly register: Registry;
    readonly prefix: string;
    readonly labels: {
        [name: string]: string;
    };
    new (options?: IAutometricStreamOptions): PassThrough;
}
export declare function createAutometricStreamPipe(name: string, baseOptions?: IAutometricCreateOptions): IAutometricStreamPipeConstructor;
